
;PureSFX v1.1 Archive Maker
;(c)2006 Trutia Alexandru

 Enumeration
  #Window_0
 EndEnumeration

 Global Image0,Count.l,FilesAdded,Path.s,TempZIP.s,File.s,Working,Threaddie

 Image0 = CatchImage(0, ?Image0)
 
 Procedure PureSFXCallback(File.s, PerCent.f)
  SetGadgetState(4,PerCent)
  SetGadgetText(5,GetFilePart(File.s))
 EndProcedure

 Procedure PureSFXCount(EntryPath.s)
  If Right(EntryPath.s,1)<>"\":EntryPath + "\":EndIf
  Count.l
  UsedDirectory = ExamineDirectory(#PB_Any, EntryPath, "*.*")
  While NextDirectoryEntry(UsedDirectory)
    EntryType.l = DirectoryEntryType(UsedDirectory)
    EntryName.s = DirectoryEntryName(UsedDirectory)
    If EntryName = "." Or EntryName = ".."
     Continue
    EndIf
    If EntryType = #PB_DirectoryEntry_File
     Count = Count + 1
    EndIf
    If EntryType = #PB_DirectoryEntry_Directory
     PureSFXCount(EntryPath + EntryName)
    EndIf
  Wend: FinishDirectory(UsedDirectory)
  ProcedureReturn Count
 EndProcedure
 
 Procedure.s PureSFXTempFile(name$)
  tmpdir$ = GetTemporaryDirectory()
  Repeat
   tmp$ = tmpdir$ + name$ + Str(Random(99))
  Until FileSize(tmp$) = -1
  ProcedureReturn tmp$
 EndProcedure
 
 Procedure PureSFXMakeEXE()
  DisableGadget(6,1)
  DisableGadget(7,1)
  DisableGadget(3,1)
  Count = PureSFXCount(Path)
  FilesAdded = PureZIP_AddFiles(TempZIP, Path+"*.*", #PureZIP_StorePathRelative, #PureZIP_Recursive)
  If Count = FilesAdded
   If ReadFile(0,TempZIP)
    SizeT = Lof(0)
    *Temp = AllocateMemory(SizeT)
    ReadData(0,*Temp,SizeT)
    CloseFile(0)
    CreateFile(0,File)
    WriteData(0,?StubStart, ?StubEnd - ?StubStart)
    WriteData(0,*Temp,SizeT)
    WriteLong(0,SizeT)
    CloseFile(0)
   EndIf
  EndIf
  Debug SizeT
  DeleteFile(TempZIP)
  FreeMemory(*Temp)
  MessageRequester("Ready","The archive was created sucessfully. "+Str(FilesAdded)+" files were added.",#MB_ICONINFORMATION)
  Working = 0
  TempZIP = ""
  Path = ""
  File = ""
  SizeT = 0
  Count = 0
  SetGadgetState(4,0)
  DisableGadget(6,0)
  DisableGadget(7,0)
  DisableGadget(3,0)
  SetGadgetText(5,"Ready...")
  ProcedureReturn
 EndProcedure

  If OpenWindow(#Window_0, 405, 334, 253, 161, "PureSFX v1.0", #PB_Window_TitleBar )
    If CreateGadgetList(WindowID(#Window_0))
      StringGadget(0, 5, 60, 180, 20, "")
      ImageGadget(1, 0, 0, 253, 34, Image0)
      TextGadget(2, 5, 45, 245, 15, "Choose your folder:")
      ButtonGadget(3, 190, 60, 60, 20, "Browse")
      ProgressBarGadget(4, 5, 110, 240, 15, 0, 100)
      TextGadget(5, 5, 90, 240, 15, "Ready...")
      ButtonGadget(6, 125, 135, 60, 20, "Exit")
      ButtonGadget(7, 190, 135, 60, 20, "Squeeze!")
      ButtonGadget(8, 5, 135, 60, 20, "About")
    EndIf
  EndIf
  
  LoadFont(0,"Arial",8)
  SetGadgetFont(#PB_Any,FontID(0))
  
  Repeat
   event = WaitWindowEvent()
   If event = #PB_Event_Gadget
    Select EventGadget()
     Case 8
      MessageRequester("About PureSFX","PureSFX v1.1"+Chr(10)+Chr(13)+Chr(10)+Chr(13)+"Description: PureSFX is a small tool to make"+Chr(10)+Chr(13)+"Self-Extracting ZIP archives."+Chr(10)+Chr(13)+"(c)2006 Trutia Alexandru."+Chr(10)+Chr(13)+"Special thanks to Gnozal for PureZIP and all the help.",64)
     Case 6
      End
     Case 3
      Path.s = PathRequester("Choose a path please","")
      If Path <> ""
       If Right(Path,1) <> "\"
        Path + "\"
       EndIf
       SetGadgetText(0,Path)
      EndIf
     Case 7
      If Working = 1
       KillThread(Threaddie)
       Working = 0
      EndIf
      Path.s = GetGadgetText(0)
      If Path <> ""
       If Right(Path,1) <> "\"
        Path + "\"
       EndIf
       File.s = SaveFileRequester("Please choose file to save", "", "Executable files (*.exe)|*.exe", 0)
       If File <> ""
        If Right(File,4) <> ".exe":File=File+".exe":EndIf
         TempZIP.s = PureSFXTempFile("PureSFX")
         PureZIP_SetCallback(@PureSFXCallback())
         Threaddie = CreateThread(@PureSFXMakeEXE(),0)
         Working = 1
        EndIf
       EndIf
    EndSelect
   EndIf
  ForEver

 DataSection
 Image0:
   IncludeBinary "LOGO2.bmp"
 StubStart:
   IncludeBinary "Stub.exe"
 StubEnd:
 EndDataSection
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableXP
; UseIcon = 32.ico
; Executable = PureSFX.exe
; IncludeVersionInfo
; VersionField0 = 0.2
; VersionField1 = 1.1
; VersionField2 = FrostLabs Software
; VersionField3 = PureSFX
; VersionField4 = 1.1
; VersionField5 = 0.2
; VersionField6 = PureSFX Archive Maker
; VersionField7 = PureSFX
; VersionField8 = None
; VersionField9 = (c)2006 Trutia Alexandru
; VersionField13 = frostlabs@xhost.ro
; VersionField14 = www.frostlabs.xhost.ro
; VersionField16 = VFT_APP